﻿using Avalonia;
using Avalonia.Controls;
using Avalonia.Controls.Documents;
using Avalonia.Controls.Shapes;
using Avalonia.Media;
using Avalonia.Threading;
using ReactiveUI;
using System;
using System.Collections.Generic;
using System.Linq;

namespace CaptchaAndSimpleCalculator.ViewModels
{
    public class MainWindowViewModel : ViewModelBase
    {
        UserControl us = new PageAuth();

        public UserControl US { get => us; set => this.RaiseAndSetIfChanged(ref us, value); }

        private AuthViewModel authvm = new();

        public AuthViewModel Authvm { get => authvm; set => authvm = value; }

        private CalculatorViewModel calculvm = new();

        public CalculatorViewModel Calculvm { get => calculvm; set => calculvm = value; }

        public void toPageAuth()
        {
            Authvm.Login = "";
            Authvm.Password = "";
            Authvm.CheckAuth = "";
            Authvm.Button1IsVisible = true;
            US = new PageAuth();
        }

        public void toPagecalculator()
        {
            US = new Pagecalculator();
        }

        public void CheckAuth()
        {
            if (Authvm.Login != "" && Authvm.Login == Models.LoginAndPassword.login && Authvm.Password != "" && Authvm.Password == Models.LoginAndPassword.password)
            {
                toPagecalculator();
            }
            else
            {
                Authvm.CheckAuth = "Неуспешная авторизация";
                Authvm.CreateCaptha();
            }
        }

        public void CheckKod()
        {
            if (Authvm.Kod == String.Join("", Authvm.KodList) && Authvm.Kod != "" && Authvm.Password != "" && Authvm.Password == Models.LoginAndPassword.password && Authvm.Login != "" && Authvm.Login == Models.LoginAndPassword.login && Authvm.ErroneousAuth == 1)
            {
                Authvm.TextBoxISVisible = false;
                Authvm.Button2IsVisible = false;
                Authvm.Captcha.IsVisible = false;
                Authvm.Kod = "";
                Authvm.KodList.Clear();
                toPagecalculator();
            }
            else if (Authvm.Kod == String.Join("", Authvm.KodList) && Authvm.Kod != "" && Authvm.Password != "" && Authvm.Password == Models.LoginAndPassword.password && Authvm.Login != "" && Authvm.Login == Models.LoginAndPassword.login && Authvm.ErroneousAuth > 1)
            {
                Authvm.TextBoxISVisible = false;
                Authvm.Button2IsVisible = false;
                Authvm.Captcha.IsVisible = false;
                Authvm.Kod = "";
                Authvm.KodList.Clear();
                toPagecalculator();
            }
            else if ((Authvm.Kod != String.Join("", Authvm.KodList) || Authvm.Kod != "" || Authvm.Password == "" || Authvm.Password != Models.LoginAndPassword.password || Authvm.Login == "" || Authvm.Login != Models.LoginAndPassword.login))
            {
                Authvm.StartTimer();
            }
        }       
    }
}
